/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Reflow.xs. Do not edit this file, edit Reflow.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Reflow.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


/* convert a hex string to an array of ints */

int*
hex_to_array(str)
    char* str;
{
  int *a;
  int i, j, n, v;

  n = strlen(str) / 8;
  New(0, a, n, int);
  for (i = 0; i < n; i++) {
    v = 0;
    for (j = 0; j < 8; j++) {
      v = v << 4;
      if (str[i*8 + j] >= 'a') {
	v = v + str[i*8 + j] - 'a' + 10;
      } else {
	v = v + str[i*8 + j] - '0';
      }
    }
    a[i] = v;
  }
  return(a);
}


/* Pack an array of ints into a hex string */

char*
array_to_hex(a, n)
    int* a;
    int n;
{
  char *res;
  char s[9];
  int i;

  New(0, res, n * 8 + 1, char);
  res[0] = 0;
  for (i = 0; i < n; i++) {
    sprintf(s, "%08x", a[i]);
    strcat(res, s);
  }
  return(res);
}


char*
reflow_trial(optimum_c, maximum, wordcount,
	     penaltylimit, semantic, shortlast,
	     word_len_c, space_len_c, extra_c,
	     result)
    int   maximum, wordcount, penaltylimit, semantic, shortlast;
    char  *optimum_c, *word_len_c, *space_len_c, *extra_c;
    char  *result;
{
    int   *optimum, *word_len, *space_len, *extra;

    int   *linkbreak, *totalpenalty, *best_linkbreak;
    int   lastbreak, i, j, k, interval, penalty, bestsofar;
    int   best_lastbreak, opt;
    char  *best_linkbreak_c;
    int   opts, ii, count;
    int   best = penaltylimit * 21;

    optimum = hex_to_array(optimum_c);
    word_len = hex_to_array(word_len_c);
    space_len = hex_to_array(space_len_c);
    extra = hex_to_array(extra_c);

    count = wordcount * sizeof(int);
    New(0, linkbreak, count, int);
    New(0, totalpenalty, count, int);
    New(0, best_linkbreak, count, int);

  /* Keep gcc -Wall happy: */
  best_lastbreak = 0;

  /* size of optimum array: */
  opts = strlen(optimum_c) / 8;

  for (i = 0; i < opts; i++) {
    opt = optimum[i];
    for (j = 0; j < wordcount; j++) {
      interval = 0;
      totalpenalty[j] = penaltylimit * 2;
      for (k = j; k >= 0; k--) {
	interval += word_len[k];
	if ((k < j) && ((interval > opt + 10)
			  || (interval >= maximum))) {
	  break;
	}
	penalty = (interval - opt) * (interval - opt);
	interval += space_len[k];
	if (k > 0) {
	  penalty += totalpenalty[k-1];
	}
	penalty -= (extra[j] * semantic)/2;
	if (penalty < totalpenalty[j]) {
	  totalpenalty[j] = penalty;
	  linkbreak[j] = k-1;
	}
      }
    }
    interval = 0;
    bestsofar = penaltylimit * 20;
    lastbreak = wordcount-2;
    /* Pick a break for the last line which gives */
    /* the least penalties for previous lines: */
    for (k = wordcount-2; k >= -1; k--) {
      interval += word_len[k+1];
      if ((interval > opt + 10) || (interval > maximum)) {
	break;
      }
      if (interval > opt) {
	penalty = (interval - opt) * (interval - opt);
      } else {
	penalty = 0;
      }
      interval += space_len[k+1];
      if (k >= 0) {
	penalty += totalpenalty[k];
      }
      if (wordcount - k - 1 <= 2) {
	penalty += shortlast * semantic;
      }
      if (penalty <= bestsofar) {
	bestsofar = penalty;
	lastbreak = k;
      }
    }
    /* Save these breaks if they are an improvement: */
    if (bestsofar < best) {
      best_lastbreak = lastbreak;
      for (ii = 0; ii < wordcount; ii++) {
	best_linkbreak[ii] = linkbreak[ii];
      }
      best = bestsofar;
    }
  }

  /* Return the best breaks, */
  /* ie return the array ($best_lastbreak, @best_linkbreak) as a hex string */
  best_linkbreak_c = array_to_hex(best_linkbreak, wordcount);
  sprintf(result, "%08x", best_lastbreak);
  strcat(result, best_linkbreak_c);

  Safefree(optimum);
  Safefree(word_len);
  Safefree(space_len);
  Safefree(extra);
  Safefree(linkbreak);
  Safefree(totalpenalty);
  Safefree(best_linkbreak);
  Safefree(best_linkbreak_c);

  return(result);  
}



#line 178 "Reflow.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 322 "Reflow.c"

XS_EUPXS(XS_Text__Reflow_reflow_trial); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Reflow_reflow_trial)
{
    dVAR; dXSARGS;
    if (items != 10)
       croak_xs_usage(cv,  "optimum, maximum, wordcount, penaltylimit, semantic, shortlast, word_len, space_len, extra, result");
    {
	int	maximum = (int)SvIV(ST(1))
;
	int	wordcount = (int)SvIV(ST(2))
;
	int	penaltylimit = (int)SvIV(ST(3))
;
	int	semantic = (int)SvIV(ST(4))
;
	int	shortlast = (int)SvIV(ST(5))
;
	char*	optimum = (char *)SvPV_nolen(ST(0))
;
	char*	word_len = (char *)SvPV_nolen(ST(6))
;
	char*	space_len = (char *)SvPV_nolen(ST(7))
;
	char*	extra = (char *)SvPV_nolen(ST(8))
;
	char*	result = (char *)SvPV_nolen(ST(9))
;
	char *	RETVAL;
	dXSTARG;

	RETVAL = reflow_trial(optimum, maximum, wordcount, penaltylimit, semantic, shortlast, word_len, space_len, extra, result);
	sv_setpv((SV*)ST(9), result);
	SvSETMAGIC(ST(9));
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Text__Reflow); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__Reflow)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Text::Reflow::reflow_trial", XS_Text__Reflow_reflow_trial, file, "$$$$$$$$$$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
